;===>
Graphics3D 800,600,16,2
SetBuffer BackBuffer()
Dither True 
;WireFrame True 
;===> 
Include "commontype.bb"
;Include "Shadow_Include.bb"
Include "Shadow_IncludeNew.bb"

;===>
camera = CreateCamera()
PositionEntity camera,0,-2,-7;4
SHW_Init()
;===>
;plane=CreatePlane() ; map
plane=CreateTerrain(64)
Goto jump
	For j=0 To 63
		For i=0 To 63
			ModifyTerrain(plane,i,j,Rnd(0.0,1.0))
		Next
	Next
.jump
;ScaleEntity plane,1,1.5,1
PositionEntity plane,-30,0,-30
TerrainShading plane,True
EntityParent plane,Scena
TranslateEntity plane,0,-5,0
EntityColor plane,255,255,255
;===>
lime=CreateSphere(4) ; position of light
EntityParent (lime,Scena)
ScaleEntity lime,0.2,0.2,0.2
light=CreateLight(2)
LightRange light,7 
;PositionEntity light,0,4,0
EntityParent light,lime
PositionEntity lime,0,2,0
EntityFX lime,2 
;===>
AmbientLight 32,32,64 

;===>
Global cube
;cube=LoadMesh("imp.x")
;Global dragonskin = LoadTexture("imp_d.png")
;EntityTexture cube,dragonskin,0,3
;ScaleEntity cube,0.05,0.05,0.05
;RotateEntity cube,0,-90,0
;PositionEntity cube,-2,-4.5,0
;===>
;cube=LoadMesh("testobject1.3DS")
;ScaleEntity cube,0.1,0.1,0.1
;cube=LoadMesh("testobject2.b3d")
;ScaleEntity cube,0.2,0.2,0.2
;PositionEntity cube,-2,-1,0
;===>
;cube=CreateSphere(16) ;Sphera settata per il test
cube=CreateCube() ; object to cast shadow
;cube=CreateCylinder(16) ; object to cast shadow
;cube=CreateCone(10) ; object to cast shadow
;cube=CreatePlane() ; object to cast shadow
;PositionEntity cube,-2,0,0
;===>
Global kx=2
Global ky=2
Global kz=2
Global offset=1
Dim Mcube(kx*2,ky*2,kz*2)
MultyCube()
HideEntity cube
;===>
Global LightRX#=0
Global Dist#=4

Global Tim_Min=10000
Global Tim_Max=0

Global Vol=False

;===>
; inizializzazione oggetti
;clone=CopyMesh(cube)
;ScaleEntity clone,0.05,0.05,0.05
;RotateEntity clone,0,0,0
;PositionEntity clone,-EntityX(cube),EntityY(cube),EntityZ(cube)
;EntityParent (cube,Scena)
;EntityParent (clone,Scena)

;TimeInit$ = SHW_InitObject(cube) ;<----- inizializzazione oggetto 1
;SHW_InitObject(clone);<----- inizializzazione oggetto 2
;===>

While KeyDown(1)=0
	;===>
	Tim1=MilliSecs()
	;===>
	;MoveEntity lime, 0,0,-0.001
	LightRX#=LightRX#+1
	If LightRX=>360 Then LightRX#=LightRX#-360
	;LightRX#=90;270
	PositionEntity lime,Dist*Cos(LightRX),4,Dist*Sin(LightRX)
	PositionEntity light,Dist*Cos(LightRX),4,Dist*Sin(LightRX)
	;TurnEntity cube,1,1,0
	;===>
	If KeyDown(78) Then TurnEntity cube,0,+2,0
	If KeyDown(74) Then TurnEntity cube,0,-2,0
	;===>
	If KeyDown(200) Then MoveEntity Camera,0,0,+0.5
	If KeyDown(208) Then MoveEntity Camera,0,0,-0.5
	;===>
	If KeyDown(203) Then TurnEntity Camera,0,+2,0
	If KeyDown(205) Then TurnEntity Camera,0,-2,0
	;===>
	If KeyDown(201) Then MoveEntity Camera,0,+0.5,0
	If KeyDown(209) Then MoveEntity Camera,0,-0.5,0
	;===>
	If KeyDown(17) Then WF=True
	If KeyDown(31) Then WF=False
	;===>

	; Key "v"
	If KeyHit(47) Then
		If  vol Then
			Vol=False 
		Else
			Vol=True
		EndIf
	EndIf
	;===>
	WireFrame False 
	S$=ShadowVolume(lime,40,vol) ;<--- Aggiorniamo l'ombra
	If WF Then WireFrame True
	;===>
	;===>
	If vol Then
		SHWLine3D()
	EndIf
	;===>
	;DrawImage SHWScreenImage,0,400
	FPS()

	Tim2=MilliSecs()
	Tim=Tim2-Tim1
	If Tim_Min>Tim Then Tim_Min=tim
	If Tim_Max<Tim Then Tim_Max=tim
	;===>
	Text 10,30,S$
	Text 10,45,"ShadowVolume  Time Min: "+Tim_Min+"  Max : "+Tim_Max+"  Real Time : "+Tim
	Text 10,60,"Make Triangle: "+TrisRendered()+" Angle: "+LightRX
	Text 10,90,"Istruction:"
	Text 10,105,"v = Show Volume"
	Text 10,120,"Cursor+Pg Up/Down = Move Camera"
	Text 10,135,"Kpad + / - = Rotate Object"
	Text 10,150, TimeInit
	;===>
	Flip
	;===>
Wend
End

Function MultyCube()
	;===>
	For x=-kx To kx Step 1 
		;===>
		For y=-ky To ky Step 1 
			;===>
			For z=-kz To kz Step 1 
				;===>
				Mcube(x+kx,y+ky,z+kz)=CopyMesh(cube)
				ScaleEntity Mcube(x+kx,y+ky,z+kz),0.2,0.2,0.2
				PositionEntity Mcube(x+kx,y+ky,z+kz),offset*x,offset*y,offset*z
				;===>
				SHW_InitObject(Mcube(x+kx,y+ky,z+kz))
				;===>
			Next
			;===>
		Next
		;===>
	Next 
	;===>

End Function 
